<?php
/*************************************************************************************/
/*                                                                                   */
/*      Thelia	                                                            		 */
/*                                                                                   */
/*      Copyright (c) Octolys Development		                                     */
/*		email : thelia@octolys.fr		        	                             	 */
/*      web : http://www.octolys.fr						   							 */
/*                                                                                   */
/*      This program is free software; you can redistribute it and/or modify         */
/*      it under the terms of the GNU General Public License as published by         */
/*      the Free Software Foundation; either version 2 of the License, or            */
/*      (at your option) any later version.                                          */
/*                                                                                   */
/*      This program is distributed in the hope that it will be useful,              */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of               */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                */
/*      GNU General Public License for more details.                                 */
/*                                                                                   */
/*      You should have received a copy of the GNU General Public License            */
/*      along with this program; if not, write to the Free Software                  */
/*      Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA    */
/*                                                                                   */
/*************************************************************************************/
?>
<?php

	include_once(realpath(dirname(__FILE__)) . "/../../../classes/PluginsTransports.class.php");
	include_once(realpath(dirname(__FILE__)) . "/../../../classes/Message.class.php");
	include_once(realpath(dirname(__FILE__)) . "/../../../classes/Messagedesc.class.php");
	include_once(realpath(dirname(__FILE__)) . "/../../../classes/Variable.class.php");
	include_once(realpath(dirname(__FILE__)) . "/classes/Socolissimo_pr.class.php");
	include_once(realpath(dirname(__FILE__)) . "/classes/Socolissimo_ho.class.php");
	include_once(realpath(dirname(__FILE__)) . "/classes/Socolissimo_fe.class.php");
	include_once(realpath(dirname(__FILE__)) . "/classes/Socolissimo_rp.class.php");
	include_once(realpath(dirname(__FILE__)) . "/classes/Socolissimo_cmd.class.php");
	include_once(realpath(dirname(__FILE__)) . "/classes/Socolissimo_lcp.class.php");
	include_once(realpath(dirname(__FILE__)) . "/classes/Socolissimo_export.class.php");

	class Socolissimo extends PluginsTransports{


		function Socolissimo(){
			$this->PluginsTransports("socolissimo");
		}
		
		function init(){
			$this->ajout_desc("So Colissimo", "So Colissimo", "", 1);
			$test = new Message();
			if(! $test->charger("socolissimo")){
				$message = new Message();
				$message->nom = "socolissimo";
				$lastid = $message->add();

				$messagedesc = new Messagedesc();
				$messagedesc->message = $lastid;
				$messagedesc->lang = 1;
				$messagedesc->titre = "Colissimo";
				$messagedesc->description = "__RAISON__ __NOM__ __PRENOM__,\n\nNous vous remercions de votre commande sur notre site __URLSITE__\n\nUn colis concernant votre commande __COMMANDE__ du __DATE__ __HEURE__ a quitt nos entrepts pour tre pris en charge par La Poste le __DATEDJ__.\n\nSon numro de suivi est le suivant : __COLIS__\nIl vous permet de suivre votre colis en ligne sur le site de La Poste : www.coliposte.net\nIl vous sera, par ailleurs, trs utile si vous tiez absent au moment de la livraison de votre colis : en fournissant ce numro de Colissimo Suivi, vous pourrez retirer votre colis dans le bureau de Poste le plus proche.\n\nATTENTION ! Si vous ne trouvez pas l'avis de passage normalement dpos dans votre bote aux lettres au bout de 48 Heures jours ouvrables, n'hsitez pas  aller le rclamer  votre bureau de Poste, muni de votre numro de Colissimo Suivi.\n\nNous restons  votre disposition pour toute information complmentaire.\nCordialement";
				$messagedesc->add();

			}

			$pr = new Socolissimo_pr();
			$pr->init();		

			$ho = new Socolissimo_ho();
			$ho->init();		
			
			$fe = new Socolissimo_fe();
			$fe->init();
			
			$rp = new Socolissimo_rp();
			$rp->init();
						
			$lcp = new Socolissimo_lcp();
			$lcp->init();

			$cmd = new Socolissimo_cmd();
			$cmd->init();
			
			$export = new Socolissimo_export();
			$export->init();																		
		}

		function action(){
			global $res;

			$modules = new Modules();
			$modules->charger("socolissimo");
						
			if($_REQUEST['action'] == "transport" && $_REQUEST['socolissimo_relais'] != "" && $_REQUEST['socolissmo_modelivr'] == "2" && $_REQUEST['id'] == $modules->id){
				$_SESSION['navig']->socolissimo_relais =  $_REQUEST['socolissimo_relais'];
				$_SESSION['navig']->socolissimo_type =  2;
			}
			else
				if($_REQUEST['action'] == "transport" && $_REQUEST['socolissmo_modelivr'] == "1" && $_REQUEST['id'] == $modules->id){
				$_SESSION['navig']->socolissimo_type =  1;

				if($_REQUEST['socolissimo_rdv'] == "1")
					$_SESSION['navig']->socolissimo_rdv = 1;
				else
					$_SESSION['navig']->socolissimo_rdv = 0;
			}

			if($_REQUEST['socolissimo_portable'] != "")
				$_SESSION['navig']->socolissimo_portable = $_REQUEST['socolissimo_portable'];
		

			$res = str_replace("#SOCOLISSIMO_CHOIXRELAIS", $_SESSION['navig']->socolissimo_relais, $res);				
			$res = str_replace("#SOCOLISSIMO_RELAIS", $_REQUEST['socolissimo_relais'], $res);
			$res = str_replace("#SOCOLISSIMO_CPOSTAL", $_REQUEST['socolissimo_cpostal'], $res);
			$res = str_replace("#SOCOLISSIMO_PTTYPE", $_REQUEST['socolissimo_pttype'], $res);
			$res = str_replace("#SOCOLISSIMO_TYPE", $_REQUEST['socolissimo_type'], $res);
			$res = str_replace("#SOCOLISSIMO_CHOIXTYPE", $_SESSION['navig']->socolissimo_type, $res);
			$res = str_replace("#SOCOLISSIMO_RDV", $_SESSION['navig']->socolissimo_rdv, $res);
			
		}
		
		function avantcommande(){

			$modules = new Modules();
			$modules->charger("socolissimo");

			$urlsite = new Variable();
			$urlsite->charger("urlsite");
			
			if($_SESSION['navig']->commande->transport == $modules->id){ 
				if($_SESSION['navig']->socolissimo_type == "2" && $_SESSION['navig']->socolissimo_relais == ""){
					header("Location: " . $urlsite->valeur); exit;
				}			
			}
			
		}

		function aprescommande($commande){

			$modules = new Modules();
			$modules->charger("socolissimo");

			if($commande->transport == $modules->id){
				$socolissimo = new Socolissimo_cmd();
				$socolissimo->commande = $commande->id;
				if($_SESSION['navig']->socolissimo_type == "2"){
					$socolissimo->type = 2;
					$socolissimo->livraison = $_SESSION['navig']->socolissimo_relais;
				} 
				
				else {
					$socolissimo->type = 1;
					$socolissimo->livraison = $commande->adrlivr;
					
					if($_SESSION['navig']->socolissimo_rdv){
						$socolissimo->rdv = 1;
					}
				}

                                $socolissimo->portable = $_SESSION['navig']->socolissimo_portable;
				$socolissimo->add();
				
			}

			$_SESSION['navig']->socolissimo_relais = "";
			$_SESSION['navig']->socolissimo_rdv = "";
			$_SESSION['navig']->socolissimo_portable = "";
			
		}
				
		function calcule(){
			
			if($this->poids<=0.25) return $this->calc_port(0);
			else if($this->poids>0.25 && $this->poids<=0.5) return $this->calc_port(1);
			else if($this->poids>0.5 && $this->poids<=0.75) return $this->calc_port(2);
			else if($this->poids>0.75 && $this->poids<=1) return $this->calc_port(3);
			else if($this->poids>1 && $this->poids<=2) return $this->calc_port(4);
			else if($this->poids>2 && $this->poids<=3) return $this->calc_port(5);
			else if($this->poids>3 && $this->poids<=4) return $this->calc_port(6);
			else if($this->poids>4 && $this->poids<=5) return $this->calc_port(7);
			else if($this->poids>5 && $this->poids<=6) return $this->calc_port(8);
			else if($this->poids>6 && $this->poids<=7) return $this->calc_port(9);
			else if($this->poids>7 && $this->poids<=8) return $this->calc_port(10);
			else if($this->poids>9 && $this->poids<=10) return $this->calc_port(11);
			else if($this->poids>10 && $this->poids<=15) return $this->calc_port(12);
			else if($this->poids>15 && $this->poids<=30) return $this->calc_port(13);
			else if($this->poids>30) return $this->calc_port(14);
		
		}
		
		function calc_port($tranche){
			
			// rdv domicile +3 euros
			// $_REQUEST['socolissmo_modelivr']
			// 1 domicile, 2 relais
			// 	$_SESSION['navig']->socolissimo_rdv  1 si rdv
						
			$tarif_domicile = array(5.68, 6.45, 7.14, 7.70, 8.41, 9.13, 9.88, 10.63, 11.38, 12.13, 12.88, 13.63, 14.38, 16.30, 21.90);
			$tarif_relais = array(5.08, 5.71, 6.34, 6.80, 7.51, 8.23, 8.98, 9.73, 10.48, 11.23, 11.98, 12.73, 13.48, 15.40, 21.00);
			
			$port = 0;
			if($_SESSION['navig']->socolissimo_type == "1"){
				$port = $tarif_domicile[$tranche];
				if($_SESSION['navig']->socolissimo_rdv == "1")
					$port += 3;
			} else if($_SESSION['navig']->socolissimo_type == "2"){
				$port = $tarif_relais[$tranche];
			}
			
			return $port;
		}
		
			
		function statut($commande){

			if($commande->statut == "4"){

				if(! $commande->colis)
					return;

				$message = new Message();
				$message->charger("socolissimo");

				$messagedesc = new Messagedesc();
				$messagedesc->charger($message->id);

				$client = new Client();
				$client->charger_id($commande->client);

				if($client->raison == "1")
					$raison = "Madame";
				else
					if($client->raison == "2")
						$raison = "Mademoiselle";
				else
					if($client->raison == "3")
						$raison = "Monsieur";

				$urlsite = new Variable();
				$urlsite->charger("urlsite");

				$emailcontact = new Variable();
				$emailcontact->charger("emailcontact");

          		$jour = substr($commande->date, 8, 2);
		        $mois = substr($commande->date, 5, 2);
		        $annee = substr($commande->date, 0, 4);
                $heure = substr($commande->date, 11, 2);
                $minute = substr($commande->date, 14, 2);
                $seconde = substr($commande->date, 17, 2);

				$messagedesc->description = str_replace("__RAISON__", "$raison", $messagedesc->description);
				$messagedesc->description = str_replace("__NOM__", $client->nom, $messagedesc->description);
				$messagedesc->description = str_replace("__PRENOM__", $client->prenom, $messagedesc->description);
				$messagedesc->description = str_replace("__URLSITE__", $urlsite->valeur, $messagedesc->description);
				$messagedesc->description = str_replace("__COMMANDE__", $commande->ref, $messagedesc->description);
				$messagedesc->description = str_replace("__DATE__", $jour . "/" . $mois . "/" . $annee, $messagedesc->description);
				$messagedesc->description = str_replace("__HEURE__", $heure . ":" . $minute . ":" . $seconde, $messagedesc->description);
				$messagedesc->description = str_replace("__DATEDJ__", date("d") . "/" . date("m") . "/" . date("Y"), $messagedesc->description);
				$messagedesc->description = str_replace("__COLIS__", $commande->colis, $messagedesc->description);
				mail($client->email, $messagedesc->titre, $messagedesc->description, "From: " . $emailcontact->valeur);

			}

		}
		


        function boucle($texte, $args){
			$boucle= lireTag($args, "boucle");
			 
			
			if($boucle == "pr"){
		    	$pr = new Socolissimo_pr();
				return $pr->boucle($texte, $args);	  
			}
            
            else if($boucle == "ho"){
		    	$ho = new Socolissimo_ho();
				return $ho->boucle($texte, $args);	            
            }
            
            else if($boucle == "fe"){
		    	$fe = new Socolissimo_fe();
				return $fe->boucle($texte, $args);	            
            }  

            else if($boucle == "rp"){
		    	$rp = new Socolissimo_rp();
				return $rp->boucle($texte, $args);	            
            }

            else if($boucle == "cmd"){
		    	$rp = new Socolissimo_cmd();
				return $rp->boucle($texte, $args);	            
            }                      
         }   


		function post(){
			global $res;
			
			include_once(realpath(dirname(__FILE__)) . "/config.php");

 			 preg_match_all("`\#FILTRE_cpostalrdv\(([^\|]+)\|\|([^\|]+)\|\|([^\)]+)\)`", $res, $cut);

                    $tab1 = "";
                    $tab2 = "";
                    for($i=0; $i<count($cut[1]); $i++){
                    	
                       if(in_array($cut[1][$i], $cpostal_rdv))
                           $tab2[$i] = $cut[2][$i];
                       else
                           $tab2[$i] = $cut[3][$i];

                        $tab1[$i] = "#FILTRE_cpostalrdv(" . $cut[1][$i] . "||" . $cut[2][$i] . "||" . $cut[3][$i] . ")";
                    }


                    $res = str_replace($tab1, $tab2, $res);

                
		}
	}

?>
